]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - tools/build/beinstall.sh
Merge ^/head r344178 through r344512.
[FreeBSD/FreeBSD.git] / tools / build / beinstall.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2016 Will Andrews
4 # All rights reserved.
5 #
6 # Redistribution and use in source and binary forms, with or without
7 # modification, are permitted provided that the following conditions
8 # are met:
9 # 1. Redistributions of source code must retain the above copyright
10 #    notice, this list of conditions and the following disclaimer 
11 #    in this position and unchanged.
12 # 2. Redistributions in binary form must reproduce the above copyright
13 #    notice, this list of conditions and the following disclaimer in the
14 #    documentation and/or other materials provided with the distribution.
15 #
16 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
17 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
18 # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
19 # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
20 # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
21 # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
22 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
23 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
24 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
25 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
26 #
27 # $FreeBSD$
28 #
29 ##
30 # Install a boot environment using the current FreeBSD source tree.
31 # Requires a fully built world & kernel.
32 #
33 # Non-base tools required: beadm, pkg
34 #
35 # In a sandbox for the new boot environment, this script also runs etcupdate
36 # and pkg upgrade automatically in the sandbox.  Upon successful completion,
37 # the system will be ready to boot into the new boot environment.  Upon
38 # failure, the target boot environment will be destroyed.  In all cases, the
39 # running system is left untouched.
40 #
41 ## Usage:
42 # beinstall [optional world/kernel flags e.g. KERNCONF]
43 #
44 ## User modifiable variables - set these in the environment if desired.
45 # If not empty, 'pkg upgrade' will be skipped.
46 NO_PKG_UPGRADE="${NO_PKG_UPGRADE:-""}"
47 # Config updater - 'etcupdate' and 'mergemaster' are supported.  Set to an
48 # empty string to skip.
49 CONFIG_UPDATER="${CONFIG_UPDATER:-"etcupdate"}"
50 # Flags for etcupdate if used.
51 ETCUPDATE_FLAGS="${ETCUPDATE_FLAGS:-"-F"}"
52 # Flags for mergemaster if used.
53 MERGEMASTER_FLAGS="${MERGEMASTER_FLAGS:-"-iFU"}"
54
55
56 ########################################################################
57 ## Constants
58 ETCUPDATE_CMD="etcupdate"
59 MERGEMASTER_CMD="mergemaster"
60
61 ## Functions
62 cleanup() {
63         [ -z "${cleanup_commands}" ] && return
64         echo "Cleaning up ..."
65         for command in ${cleanup_commands}; do
66                 ${command}
67         done
68 }
69
70 errx() {
71         cleanup
72         echo "error: $@"
73         exit 1
74 }
75
76 rmdir_be() {
77         chflags -R noschg ${BE_MNTPT}
78         rm -rf ${BE_MNTPT}
79 }
80
81 unmount_be() {
82         mount | grep " on ${BE_MNTPT}" | awk '{print $3}' | sort -r | xargs -t umount -f
83 }
84
85 copy_pkgs() {
86         # Before cleaning up, try to save progress in pkg(8) updates, to
87         # speed up future updates.  This is only called on the error path;
88         # no need to run on success.
89         echo "Rsyncing back newly saved packages..."
90         rsync -av --progress ${BE_MNTPT}/var/cache/pkg/. /var/cache/pkg/.
91 }
92
93 cleanup_be() {
94         # Before destroying, unmount any child filesystems that may have
95         # been mounted under the boot environment.  Sort them in reverse
96         # order so children are unmounted first.
97         unmount_be
98         # Finally, clean up any directories that were created by the
99         # operation, via cleanup_be_dirs().
100         if [ -n "${created_be_dirs}" ]; then
101                 chroot ${BE_MNTPT} /bin/rm -rf ${created_be_dirs}
102         fi
103         beadm destroy -F ${BENAME}
104 }
105
106 create_be_dirs() {
107         echo "${BE_MNTPT}: Inspecting dirs $*"
108         for dir in $*; do
109                 curdir="$dir"
110                 topdir="$dir"
111                 while :; do
112                         [ -e "${BE_MNTPT}${curdir}" ] && break
113                         topdir=$curdir
114                         curdir=$(dirname ${curdir})
115                 done
116                 [ "$curdir" = "$dir" ] && continue
117
118                 # Add the top-most nonexistent directory to the list, then
119                 # mkdir -p the innermost directory specified by the argument.
120                 # This way the least number of directories are rm'd directly.
121                 created_be_dirs="${topdir} ${created_be_dirs}"
122                 echo "${BE_MNTPT}: Created ${dir}"
123                 mkdir -p ${BE_MNTPT}${dir} || return $?
124         done
125         return 0
126 }
127
128 update_mergemaster_pre() {
129         mergemaster -p -m ${srcdir} -D ${BE_MNTPT} -t ${BE_MM_ROOT} ${MERGEMASTER_FLAGS}
130 }
131
132 update_mergemaster() {
133         chroot ${BE_MNTPT} \
134                 mergemaster -m ${srcdir} -t ${BE_MM_ROOT} ${MERGEMASTER_FLAGS}
135 }
136
137 update_etcupdate_pre() {
138         etcupdate -p -s ${srcdir} -D ${BE_MNTPT} ${ETCUPDATE_FLAGS} || return $?
139         etcupdate resolve -D ${BE_MNTPT} || return $?
140 }
141
142 update_etcupdate() {
143         chroot ${BE_MNTPT} \
144                 etcupdate -s ${srcdir} ${ETCUPDATE_FLAGS} || return $?
145         chroot ${BE_MNTPT} etcupdate resolve
146 }
147
148
149 # Special command-line subcommand that can be used to do a full cleanup
150 # after a manual post-mortem has been completed.
151 postmortem() {
152         [ -n "${BENAME}" ] || errx "Must specify BENAME"
153         [ -n "${BE_MNTPT}" ] || errx "Must specify BE_MNTPT"
154         echo "Performing post-mortem on BE ${BENAME} at ${BE_MNTPT} ..."
155         unmount_be
156         rmdir_be
157         echo "Post-mortem cleanup complete."
158         echo "To destroy the BE (recommended), run: beadm destroy ${BENAME}"
159         echo "To instead continue with the BE, run: beadm activate ${BENAME}"
160 }
161
162 if [ -n "$BEINSTALL_CMD" ]; then
163         ${BEINSTALL_CMD} $*
164         exit $?
165 fi
166
167
168 cleanup_commands=""
169 trap 'errx "Interrupt caught"' HUP INT TERM
170
171 [ "$(whoami)" != "root" ] && errx "Must be run as root"
172
173 [ ! -f "Makefile.inc1" ] && errx "Must be in FreeBSD source tree"
174 srcdir=$(pwd)
175 objdir=$(make -V .OBJDIR 2>/dev/null)
176 [ ! -d "${objdir}" ] && errx "Must have built FreeBSD from source tree"
177
178 # May be a worktree, in which case .git is a file, not a directory.
179 if [ -e .git ] ; then
180     commit_time=$(git show --format='%ct' 2>/dev/null | head -1)
181     [ $? -ne 0 ] && errx "Can't lookup git commit timestamp"
182     commit_ts=$(date -r ${commit_time} '+%Y%m%d.%H%M%S')
183 elif [ -d .svn ] ; then
184       if [ -e /usr/bin/svnlite ]; then
185         svn=/usr/bin/svnlite
186       elif [ -e /usr/local/bin/svn ]; then
187         svn=/usr/local/bin/svn
188       else
189         errx "Unable to find subversion"
190       fi
191       commit_ts="$( "$svn" info --show-item last-changed-date | sed -e 's/\..*//' -e 's/T/./' -e 's/-//g' -e s'/://g' )"
192     [ $? -ne 0 ] && errx "Can't lookup Subversion commit timestamp"
193 else
194     errx "Unable to determine source control type"
195 fi
196
197 commit_ver=$(${objdir}/bin/freebsd-version/freebsd-version -u 2>/dev/null)
198 [ -z "${commit_ver}" ] && errx "Unable to determine FreeBSD version"
199
200 BENAME="${commit_ver}-${commit_ts}"
201
202 BE_TMP=$(mktemp -d /tmp/beinstall.XXXXXX)
203 [ $? -ne 0 -o ! -d ${BE_TMP} ] && errx "Unable to create mountpoint"
204 [ -z "$NO_CLEANUP_BE" ] && cleanup_commands="rmdir_be ${cleanup_commands}"
205 BE_MNTPT=${BE_TMP}/mnt
206 BE_MM_ROOT=${BE_TMP}/mergemaster # mergemaster will create
207 mkdir -p ${BE_MNTPT}
208
209 beadm create ${BENAME} >/dev/null || errx "Unable to create BE ${BENAME}"
210 [ -z "$NO_CLEANUP_BE" ] && cleanup_commands="cleanup_be ${cleanup_commands}"
211
212 beadm mount ${BENAME} ${BE_TMP}/mnt || errx "Unable to mount BE ${BENAME}."
213
214 echo "Mounted ${BENAME} to ${BE_MNTPT}, performing install/update ..."
215 make "$@" DESTDIR=${BE_MNTPT} installkernel || errx "Installkernel failed!"
216 if [ -n "${CONFIG_UPDATER}" ]; then
217         "update_${CONFIG_UPDATER}_pre"
218         [ $? -ne 0 ] && errx "${CONFIG_UPDATER} (pre-world) failed!"
219 fi
220
221 # Mount the source and object tree within the BE in order to account for any
222 # changes applied by the pre-installworld updater.  Cleanup any directories
223 # created if they didn't exist previously.
224 create_be_dirs "${srcdir}" "${objdir}" || errx "Unable to create BE dirs"
225 mount -t nullfs "${srcdir}" "${BE_MNTPT}${srcdir}" || errx "Unable to mount src"
226 mount -t nullfs "${objdir}" "${BE_MNTPT}${objdir}" || errx "Unable to mount obj"
227
228 chroot ${BE_MNTPT} make "$@" -C ${srcdir} installworld || \
229         errx "Installworld failed!"
230
231 if [ -n "${CONFIG_UPDATER}" ]; then
232         "update_${CONFIG_UPDATER}"
233         [ $? -ne 0 ] && errx "${CONFIG_UPDATER} (post-world) failed!"
234 fi
235
236 if which rsync >/dev/null 2>&1; then
237         cleanup_commands="copy_pkgs ${cleanup_commands}"
238 fi
239
240 BE_PKG="chroot ${BE_MNTPT} env ASSUME_ALWAYS_YES=true pkg"
241 if [ -z "${NO_PKG_UPGRADE}" ]; then
242         ${BE_PKG} update || errx "Unable to update pkg"
243         ${BE_PKG} upgrade || errx "Unable to upgrade pkgs"
244 fi
245
246 if [ -n "$NO_CLEANUP_BE" ]; then
247         echo "Boot Environment ${BENAME} may be examined in ${BE_MNTPT}."
248         echo "Afterwards, run this to cleanup:"
249         echo "  env BENAME=${BENAME} BE_MNTPT=${BE_MNTPT} BEINSTALL_CMD=postmortem $0"
250         exit 0
251 fi
252
253 unmount_be || errx "Unable to unmount BE"
254 rmdir_be || errx "Unable to cleanup BE"
255 beadm activate ${BENAME} || errx "Unable to activate BE"
256 echo
257 beadm list
258 echo
259 echo "Boot environment ${BENAME} setup complete; reboot to use it."